
#include <TimerOne.h>
#include <SD.h>
#include "LPD6803.h"


int raw;
int dat[6];
int nr = -1;
int rgb = 1;
int digit = 0;
int kleur[100][3];
int beeld = 7;
int teller = 0;
int wachttijd = 1000;
int wachtuit = 0;
int talleur = 0;
int beweging = 1;
int speciaal = 0;
int stoppen = 0;
  File dataFile;
const int chipSelect = 4;



LPD6803 strip = LPD6803(25, 7, 6);

void setup()
{
  Serial.begin(9600);
  Serial.print("Initializing SD card...");

  strip.setCPUmax(60);//start de ledstrip
  strip.begin();
  strip.show();

  pinMode(10, OUTPUT);


  if (!SD.begin(chipSelect)) {
    Serial.println("Card failed, or not present");
    // don't do anything more:
     settm(5,31,0,0);
    return;
  }
  Serial.println("card initialized.");


}

void loop()
{
 // talleur = 1;

if (beweging == 1){
   leesSD(talleur);
  if (talleur == 0)afstandanim();
   talleur++; 
   
  }

 if (talleur > 50) {
  
     
     beweging = 0;
        if (analogRead(A1) > 300){
            beweging = 1;
            talleur = 0;
        }else{
            clearall();
        }  


}





}

void afstandanim(){

  Serial.println("yay");
for (int e = 0; e < 100; e++){
Serial.print("afstand:");
int q = analogRead(A4);
Serial.println("________________");
Serial.println(digitalRead(A1));
Serial.println("________________");
Serial.println(q);
delay(100);

int w = (q / 20)-2;
clearall();
 settm(w,31,31,31);


}
}





void leesSD (long textnr){

nr = 0;
rgb = 1;
digit = 0;
dat[0] = 0;
dat[1] = 0;
dat[2] = 0;
dat[3] = 0;

int test2 = 123;

char FileName[7];
sprintf( FileName, "an%i.an", textnr );
dataFile = SD.open(FileName);



rgb = 1;
  if (dataFile) {
    while (1==1){
     raw = (dataFile.read() - 48);  
     if (raw == -4){//,
       if (nr != 25){
       kleur[nr][rgb] = dat[1] + (dat[0] * 10);}
       rgb = 1;
       nr++;  
       digit = 0;
       dat[0] = 0;
       dat[1] = 0;
     }
     
      
     if (raw == -16){// spatie
      if (nr != 25) kleur[nr][rgb] = dat[1] + (dat[0] * 10);
       digit = 0;
       dat[0] = 0;
       dat[1] = 0;
       dat[2] = 0;
       dat[3] = 0;
       
       rgb++;
     }
     
     
     
     if (raw == -10){//&
   //  IRontvangen();
   //  if (stoppen == 1){stoppen = 0;
   //  break;}
     Serial.print("volgend beeldje:");
    delay(10);
        wachttijd = dat[4] + dat[3] * 10 + dat[2] * 100 + dat [1] * 1000;
        Serial.println(wachttijd);

       rgb = 1;
       digit = 0;
       dat[0] = 0;
       dat[1] = 0;
       dat[2] = 0;
       dat[3] = 0;
       
       setkleuren();
       delay(wachttijd);
  
       nr = 0;
     }
     
     if (raw == 36){//T
       wachtuit = 1;
       digit = 0;
       rgb = 1;
       dat[1] = 0;
       dat[2] = 0;
       dat[3] = 0;
       dat[4] = 0;
       setkleuren();
     }
     
     
     
     if (raw == 15){//?
       Serial.print("kaar met animatie");
       break;
       rgb = 1;
     }


     if (raw >= 0){//getallen
       if (rgb == 4)rgb = 1;
       dat[digit] = raw;
       digit++; 
     }
   
    }

    dataFile.close();
  }  
  // if the file isn't open, pop up an error:
  else {
    Serial.println("error opening ***.txt");
  } 

}

 void setkleuren() { //zet alle kleuren uit ledkleur[][]
   for (int i=-1; i <= 25; i++){
      strip.setPixelColor(i, Color(kleur[i][3] , kleur[i][1] , kleur[i][2]));  
    } 
  strip.show();
}


void clearall() {// cleart de hele strip
  //lednr = 0;
   for (int i=0; i <= 25; i++){
      kleur[i][1] = 0;//r
      kleur[i][2] = 0;//g
      kleur[i][3] = 0;//b
    } 
  setkleuren(); 
}


void settm(int tm, int r, int g, int b) {// cleart de hele strip
  //lednr = 0;
   for (int i=0; i <= tm; i++){
      kleur[i][1] = r;//r
      kleur[i][2] = g;//g
      kleur[i][3] = b;//b
    } 
  setkleuren(); 
}



unsigned int Color(byte r, byte g, byte b) // maakt een getal van de r b en g waardes  (hoort bij de ledstrip)
{
  //Take the lowest 5 bits of each value and append them end to end
  return( ((unsigned int)g & 0x1F )<<10 | ((unsigned int)b & 0x1F)<<5 | (unsigned int)r & 0x1F);
}




